;---------------------------------------;
; Dialog as Main Example,  Version 1.0  ;
; Paul Brennick                         ;
; pbrennick@charter.net                 ;
; http://www.pbrennick.com              ;
;---------------------------------------;
        .386                            ; Minimum requirement
        .model  flat, stdcall           ; 32 bit memory model
        option  casemap :none           ; Case sensitive

;       Include Files
;       --------------------------------
        include \GeneSys\include\windows.inc
        include \GeneSys\include\user32.inc
        include \GeneSys\include\kernel32.inc

;       Libraries
;       --------------------------------
        includelib  \GeneSys\lib\user32.lib
        includelib  \GeneSys\lib\kernel32.lib

; Procedures
;---------------------------------------
SpecialProc     PROTO   :DWORD, :DWORD, :DWORD, :DWORD

.data
;---------------------------------------
DlgMain         db  'Special', 0
hInstance       dd  0
szButton1       db  'This is Button Number 1', 0
szButton2       db  'This is Button Number 2', 0
szButton3       db  'This is Button Number 3', 0
szButton4       db  'This is Button Number 4', 0
szButton5       db  'This is Button Number 5', 0
szButton6       db  'This is Button Number 6', 0

.const
;---------------------------------------;
IDC_BUTTON1     equ 2001                ; Button Number 1
IDC_BUTTON2     equ 2002                ; Button Number 2
IDC_BUTTON3     equ 2003                ; Button Number 3
IDC_BUTTON4     equ 2004                ; Button Number 4
IDC_BUTTON5     equ 2005                ; Button Number 5
IDC_BUTTON6     equ 2006                ; Button Number 6
IDC_DISPLAY     equ 2007                ; Display Window

.code
;---------------------------------------;
start:  invoke  GetModuleHandle, NULL   ; Get our app Handle from Windows
        mov     hInstance, eax          ; Store it for later use
;       --------------------------------;
;       Call the resource dialog box    ;
;       --------------------------------;
        invoke  DialogBoxParam, hInstance, ADDR DlgMain, 0, ADDR SpecialProc, 0
        invoke  ExitProcess, eax

;---------------------------------------;
; Dialog box handler                    ;
;---------------------------------------;
SpecialProc PROC  hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
;---------------------------------------;
        .if uMsg == WM_INITDIALOG       ; If first pass
          invoke  SetDlgItemText, hWin, 2007, addr szButton1
          ret                           ;
        .elseif uMsg == WM_CLOSE        ; Close
          invoke  EndDialog, hWin, 0    ; Tell the dialog box to close itself
          push    1                     ; Set Exit Code
          pop     eax                   ; Get Exit Code
          ret                           ; Exit the Program
        .elseif uMsg == WM_COMMAND      ; Call to Command Parser?
          .if wParam == IDC_BUTTON1     ; Button Number 1?
            invoke  SetDlgItemText, hWin, 2007, addr szButton1
            ret                         ; Return to Key/Mouse Watcher
          .elseif wParam == IDC_BUTTON2 ; Button Number 2?
            invoke  SetDlgItemText, hWin, 2007, addr szButton2
            ret                         ; Return to Key/Mouse Watcher
          .elseif wParam == IDC_BUTTON3 ; Button Number 3?
            invoke  SetDlgItemText, hWin, 2007, addr szButton3
            ret                         ; Return to Key/Mouse Watcher
          .elseif wParam == IDC_BUTTON4 ; Button Number 4?
            invoke  SetDlgItemText, hWin, 2007, addr szButton4
            ret                         ; Return to Key/Mouse Watcher
          .elseif wParam == IDC_BUTTON5 ; Button Number 5?
            invoke  SetDlgItemText, hWin, 2007, addr szButton5
            ret                         ; Return to Key/Mouse Watcher
          .elseif wParam == IDC_BUTTON6 ; Button Number 6?
            invoke  SetDlgItemText, hWin, 2007, addr szButton6
            ret                         ; Return to Key/Mouse Watcher
          .elseif wParam == IDCANCEL    ; Close Button?
            invoke  EndDialog, hWin, 0  ; Tell the dialog box to close
            push    1                   ; Set Exit Code
            pop     eax                 ; Get Exit Code
          ret                           ; Exit the Program
          .endif
        .endif
.data
Message1        db  'Hello, I am data in the code section', 0
Message2        db  'Hello, I am data in the code section', 0
Message3        db  'Hello, I am data in the code section', 0
.code
        xor     eax, eax
        ret
;--------------------------------------
SpecialProc   endp

       end     start
